#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private PriceActionIndicators.PADayTradingSR[] cachePADayTradingSR;
		private PriceActionIndicators.PAShallowestTrendLinesFromYesterday[] cachePAShallowestTrendLinesFromYesterday;
		private PriceActionIndicators.PAShowBidAsk[] cachePAShowBidAsk;
		private PriceActionIndicators.PASimpleAlwaysInEMA[] cachePASimpleAlwaysInEMA;
		private PriceActionIndicators.PASuppResOpenGaps[] cachePASuppResOpenGaps;

		
		public PriceActionIndicators.PADayTradingSR PADayTradingSR()
		{
			return PADayTradingSR(Input);
		}

		public PriceActionIndicators.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(int line_Thickness)
		{
			return PAShallowestTrendLinesFromYesterday(Input, line_Thickness);
		}

		public PriceActionIndicators.PAShowBidAsk PAShowBidAsk(double multiplier, int fontSize, int textOffset)
		{
			return PAShowBidAsk(Input, multiplier, fontSize, textOffset);
		}

		public PriceActionIndicators.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(int eMA_Period, int lookBack, int percent)
		{
			return PASimpleAlwaysInEMA(Input, eMA_Period, lookBack, percent);
		}

		public PriceActionIndicators.PASuppResOpenGaps PASuppResOpenGaps()
		{
			return PASuppResOpenGaps(Input);
		}


		
		public PriceActionIndicators.PADayTradingSR PADayTradingSR(ISeries<double> input)
		{
			if (cachePADayTradingSR != null)
				for (int idx = 0; idx < cachePADayTradingSR.Length; idx++)
					if ( cachePADayTradingSR[idx].EqualsInput(input))
						return cachePADayTradingSR[idx];
			return CacheIndicator<PriceActionIndicators.PADayTradingSR>(new PriceActionIndicators.PADayTradingSR(), input, ref cachePADayTradingSR);
		}

		public PriceActionIndicators.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(ISeries<double> input, int line_Thickness)
		{
			if (cachePAShallowestTrendLinesFromYesterday != null)
				for (int idx = 0; idx < cachePAShallowestTrendLinesFromYesterday.Length; idx++)
					if (cachePAShallowestTrendLinesFromYesterday[idx].Line_Thickness == line_Thickness && cachePAShallowestTrendLinesFromYesterday[idx].EqualsInput(input))
						return cachePAShallowestTrendLinesFromYesterday[idx];
			return CacheIndicator<PriceActionIndicators.PAShallowestTrendLinesFromYesterday>(new PriceActionIndicators.PAShallowestTrendLinesFromYesterday(){ Line_Thickness = line_Thickness }, input, ref cachePAShallowestTrendLinesFromYesterday);
		}

		public PriceActionIndicators.PAShowBidAsk PAShowBidAsk(ISeries<double> input, double multiplier, int fontSize, int textOffset)
		{
			if (cachePAShowBidAsk != null)
				for (int idx = 0; idx < cachePAShowBidAsk.Length; idx++)
					if (cachePAShowBidAsk[idx].multiplier == multiplier && cachePAShowBidAsk[idx].fontSize == fontSize && cachePAShowBidAsk[idx].textOffset == textOffset && cachePAShowBidAsk[idx].EqualsInput(input))
						return cachePAShowBidAsk[idx];
			return CacheIndicator<PriceActionIndicators.PAShowBidAsk>(new PriceActionIndicators.PAShowBidAsk(){ multiplier = multiplier, fontSize = fontSize, textOffset = textOffset }, input, ref cachePAShowBidAsk);
		}

		public PriceActionIndicators.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(ISeries<double> input, int eMA_Period, int lookBack, int percent)
		{
			if (cachePASimpleAlwaysInEMA != null)
				for (int idx = 0; idx < cachePASimpleAlwaysInEMA.Length; idx++)
					if (cachePASimpleAlwaysInEMA[idx].eMA_Period == eMA_Period && cachePASimpleAlwaysInEMA[idx].lookBack == lookBack && cachePASimpleAlwaysInEMA[idx].percent == percent && cachePASimpleAlwaysInEMA[idx].EqualsInput(input))
						return cachePASimpleAlwaysInEMA[idx];
			return CacheIndicator<PriceActionIndicators.PASimpleAlwaysInEMA>(new PriceActionIndicators.PASimpleAlwaysInEMA(){ eMA_Period = eMA_Period, lookBack = lookBack, percent = percent }, input, ref cachePASimpleAlwaysInEMA);
		}

		public PriceActionIndicators.PASuppResOpenGaps PASuppResOpenGaps(ISeries<double> input)
		{
			if (cachePASuppResOpenGaps != null)
				for (int idx = 0; idx < cachePASuppResOpenGaps.Length; idx++)
					if ( cachePASuppResOpenGaps[idx].EqualsInput(input))
						return cachePASuppResOpenGaps[idx];
			return CacheIndicator<PriceActionIndicators.PASuppResOpenGaps>(new PriceActionIndicators.PASuppResOpenGaps(), input, ref cachePASuppResOpenGaps);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.PriceActionIndicators.PADayTradingSR PADayTradingSR()
		{
			return indicator.PADayTradingSR(Input);
		}

		public Indicators.PriceActionIndicators.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(int line_Thickness)
		{
			return indicator.PAShallowestTrendLinesFromYesterday(Input, line_Thickness);
		}

		public Indicators.PriceActionIndicators.PAShowBidAsk PAShowBidAsk(double multiplier, int fontSize, int textOffset)
		{
			return indicator.PAShowBidAsk(Input, multiplier, fontSize, textOffset);
		}

		public Indicators.PriceActionIndicators.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(int eMA_Period, int lookBack, int percent)
		{
			return indicator.PASimpleAlwaysInEMA(Input, eMA_Period, lookBack, percent);
		}

		public Indicators.PriceActionIndicators.PASuppResOpenGaps PASuppResOpenGaps()
		{
			return indicator.PASuppResOpenGaps(Input);
		}


		
		public Indicators.PriceActionIndicators.PADayTradingSR PADayTradingSR(ISeries<double> input )
		{
			return indicator.PADayTradingSR(input);
		}

		public Indicators.PriceActionIndicators.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(ISeries<double> input , int line_Thickness)
		{
			return indicator.PAShallowestTrendLinesFromYesterday(input, line_Thickness);
		}

		public Indicators.PriceActionIndicators.PAShowBidAsk PAShowBidAsk(ISeries<double> input , double multiplier, int fontSize, int textOffset)
		{
			return indicator.PAShowBidAsk(input, multiplier, fontSize, textOffset);
		}

		public Indicators.PriceActionIndicators.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(ISeries<double> input , int eMA_Period, int lookBack, int percent)
		{
			return indicator.PASimpleAlwaysInEMA(input, eMA_Period, lookBack, percent);
		}

		public Indicators.PriceActionIndicators.PASuppResOpenGaps PASuppResOpenGaps(ISeries<double> input )
		{
			return indicator.PASuppResOpenGaps(input);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.PriceActionIndicators.PADayTradingSR PADayTradingSR()
		{
			return indicator.PADayTradingSR(Input);
		}

		public Indicators.PriceActionIndicators.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(int line_Thickness)
		{
			return indicator.PAShallowestTrendLinesFromYesterday(Input, line_Thickness);
		}

		public Indicators.PriceActionIndicators.PAShowBidAsk PAShowBidAsk(double multiplier, int fontSize, int textOffset)
		{
			return indicator.PAShowBidAsk(Input, multiplier, fontSize, textOffset);
		}

		public Indicators.PriceActionIndicators.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(int eMA_Period, int lookBack, int percent)
		{
			return indicator.PASimpleAlwaysInEMA(Input, eMA_Period, lookBack, percent);
		}

		public Indicators.PriceActionIndicators.PASuppResOpenGaps PASuppResOpenGaps()
		{
			return indicator.PASuppResOpenGaps(Input);
		}


		
		public Indicators.PriceActionIndicators.PADayTradingSR PADayTradingSR(ISeries<double> input )
		{
			return indicator.PADayTradingSR(input);
		}

		public Indicators.PriceActionIndicators.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(ISeries<double> input , int line_Thickness)
		{
			return indicator.PAShallowestTrendLinesFromYesterday(input, line_Thickness);
		}

		public Indicators.PriceActionIndicators.PAShowBidAsk PAShowBidAsk(ISeries<double> input , double multiplier, int fontSize, int textOffset)
		{
			return indicator.PAShowBidAsk(input, multiplier, fontSize, textOffset);
		}

		public Indicators.PriceActionIndicators.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(ISeries<double> input , int eMA_Period, int lookBack, int percent)
		{
			return indicator.PASimpleAlwaysInEMA(input, eMA_Period, lookBack, percent);
		}

		public Indicators.PriceActionIndicators.PASuppResOpenGaps PASuppResOpenGaps(ISeries<double> input )
		{
			return indicator.PASuppResOpenGaps(input);
		}

	}
}

#endregion
